export interface Route<Parts extends Array<PathPart<any>>, QueryParams extends string[] = []> {
    template(): string;
    create(params: Record<ParamsFromPathArray<Parts>[number], string> & Partial<{
        query: Partial<Record<QueryParams[number], string>>;
    }>): string;
    withQueryParams: <T extends string[]>(...params: T) => Route<Parts, [QueryParams[number] | T[number]]>;
    parse(queryString: string): Partial<Record<QueryParams[number], string>>;
}
export interface PathParam<T extends string> {
    param: T;
}
export declare type PathPart<T extends string> = string | PathParam<T>;
export declare type ParamsFromPathArray<T extends Array<PathPart<any>>> = {
    [K in keyof T]: T[K] extends PathParam<infer ParamName> ? ParamName : never;
};
export declare type RouteParams<T extends Route<any, any>> = T extends Route<infer X, any> ? Record<ParamsFromPathArray<X>[number], string> : never;
